<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CarSupplement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CarSupplement extends AbstractStructArrayBase
{
    /**
     * The CarSupplement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CarSupplement[]
     */
    public $CarSupplement;
    /**
     * Constructor method for ArrayOfJP_CarSupplement
     * @uses ArrayOfJP_CarSupplement::setCarSupplement()
     * @param \StructType\JP_CarSupplement[] $carSupplement
     */
    public function __construct(array $carSupplement = array())
    {
        $this
            ->setCarSupplement($carSupplement);
    }
    /**
     * Get CarSupplement value
     * @return \StructType\JP_CarSupplement[]|null
     */
    public function getCarSupplement()
    {
        return $this->CarSupplement;
    }
    /**
     * This method is responsible for validating the values passed to the setCarSupplement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCarSupplement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCarSupplementForArrayConstraintsFromSetCarSupplement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CarSupplementCarSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CarSupplementCarSupplementItem instanceof \StructType\JP_CarSupplement) {
                $invalidValues[] = is_object($arrayOfJP_CarSupplementCarSupplementItem) ? get_class($arrayOfJP_CarSupplementCarSupplementItem) : sprintf('%s(%s)', gettype($arrayOfJP_CarSupplementCarSupplementItem), var_export($arrayOfJP_CarSupplementCarSupplementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CarSupplement property can only contain items of type \StructType\JP_CarSupplement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CarSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CarSupplement[] $carSupplement
     * @return \ArrayType\ArrayOfJP_CarSupplement
     */
    public function setCarSupplement(array $carSupplement = array())
    {
        // validation for constraint: array
        if ('' !== ($carSupplementArrayErrorMessage = self::validateCarSupplementForArrayConstraintsFromSetCarSupplement($carSupplement))) {
            throw new \InvalidArgumentException($carSupplementArrayErrorMessage, __LINE__);
        }
        $this->CarSupplement = $carSupplement;
        return $this;
    }
    /**
     * Add item to CarSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CarSupplement $item
     * @return \ArrayType\ArrayOfJP_CarSupplement
     */
    public function addToCarSupplement(\StructType\JP_CarSupplement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CarSupplement) {
            throw new \InvalidArgumentException(sprintf('The CarSupplement property can only contain items of type \StructType\JP_CarSupplement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CarSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CarSupplement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CarSupplement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CarSupplement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CarSupplement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CarSupplement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CarSupplement
     */
    public function getAttributeName()
    {
        return 'CarSupplement';
    }
}
